// functiile necesare
void Init()
{
	for ( int i = 1; i <= n; i++ )
		t[i] = i;
}

// O(1)
void Union(int r1, int r2)   // O(1)
{
	t[r1] = r2;
}

// O(1) amortizat
int Find(int x)      // cautare cu compresie recursiv
{
	if (x == t[x]) return x;
	return t[x] = Find(t[x]);
}

int Find(int x)   // cautare cu compresie iterativ
{
	long int rad = x;
	while (rad != t[rad] )
		rad = t[rad];

	long int f;
	while (x != rad ) // compresie
	{
		f = t[x];
		t[x] = rad;
		x = f;
	}
	return rad;
}
