#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
using namespace std;


template <typename First, typename Second>
struct pair {

    bool operator < (pair const& p) const noexcept
    {
        return first < p.first ||
               (first == p.first && second < p.second);
    }
    First first;
    Second second;
};


int main()
{
    pair<string, int> p1 = {"Ionel", 18};
    pair<string, int> p2 = {"Marcel", 18};

    if (p1 < p2)
        cout << "p1 < p2";
}
